diff --git a/init.c b/init.c
index 63604407a5..d99bb58aa5 100644
--- a/init.c
+++ b/init.c
@@ -697,7 +697,13 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
     else
       mutt_buffer_addch(dest, ch);
   }
+
   SKIPWS(tok->dptr);
+
+  /* Terminate the string. This is needed if no token could be extracted, in
+   * which case dest must be the empty string. */
+  mutt_buffer_addch(dest, 0);
+
   return 0;
 }
 
